//Title:        SwingTiffy
//Version:      2.5.3
//Copyright:    Copyright (c) 2000,2002
//Author:       Helge Hackbarth
//Description:  Toolbar for Swing-Tiffy

package ach;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
// Depending on the version of Swing classes you have to use
// either the import statement for com.sun.java.swing.* (e.g. in Jbuilder2)
// or for javax.swing.*; (e.g. for JDK 1.2)
// import com.sun.java.swing.*; // packages for Swing 1.0 classes (remove if not used)
import javax.swing.*;        // packages for Swing 1.1 classes (remove if not used)
import ach.ImagePanel;       // Panel containing image, scrollbars and other controls
import ach.MinLabel;         // Component derived from Label with optimized sizing
import ach.ToolbarController;// interface to control some components of the toolbar
import ach.JTScrollBar;

public class JTiffyToolBar extends JToolBar
                           implements ActionListener, MouseListener, ToolbarController {
  ImagePanel imagePanel; // receiver for actionevents
  //ImageIcon zoomInIcon = new ImageIcon("ach/zoomplus.gif");
  ImageIcon saveIcon = loadImageIcon("save.gif");
  ImageIcon navigationIcon = loadImageIcon("grabhand.gif");
  ImageIcon zoomInIcon = loadImageIcon("zoomplus.gif");
  ImageIcon zoomOutIcon = loadImageIcon("zoominus.gif");
  ImageIcon zoom1To1Icon = loadImageIcon("1to1.gif");
  ImageIcon horizScaleIcon = loadImageIcon("horscale.gif");
  ImageIcon winScaleIcon = loadImageIcon("winscale.gif");
  ImageIcon antialiaIcon = loadImageIcon("antialia.gif");
  ImageIcon pgBackIcon = loadImageIcon("pgback.gif");
  ImageIcon pgFwdIcon = loadImageIcon("pgfwd.gif");
  ImageIcon turnleftIcon = loadImageIcon("turnleft.gif");
  ImageIcon turn180Icon = loadImageIcon("turn180.gif");
  ImageIcon turnrghtIcon = loadImageIcon("turnrght.gif");
  ImageIcon mirrorIcon = loadImageIcon("mirror.gif");
  ImageIcon flipIcon = loadImageIcon("flip.gif");
  ImageIcon invertIcon = loadImageIcon("invert.gif");
  ImageIcon annotationIcon = loadImageIcon("annotation.gif");
  ImageIcon printIcon = loadImageIcon("printer.gif");
  ImageIcon printViewIcon = loadImageIcon("printview.gif");
  ImageIcon helpIcon = loadImageIcon("help.gif");
  JButton saveBtn = new JButton();
  JButton navigationBtn = new JButton();
  JButton zoomOutBtn = new JButton();
  JButton zoomInBtn = new JButton();
  JButton zoom1to1Btn = new JButton();
  JButton horizScaleBtn = new JButton();
  JButton winScaleBtn = new JButton();
  JToggleButton antialiasBtn = new JToggleButton();
  JButton pgBackBtn = new JButton();
  JButton pgFwdBtn = new JButton();
  JButton turnLeftBtn = new JButton();
  JButton turnRghtBtn = new JButton();
  JButton turn180Btn = new JButton();
  JButton mirrorBtn = new JButton();
  JButton flipBtn = new JButton();
  JButton printBtn = new JButton();
  JButton printViewBtn = new JButton();
  JButton invertBtn = new JButton();
  JToggleButton annotationBtn = new JToggleButton(annotationIcon, true);
  JButton helpBtn = new JButton();
  JTextField tfZoom = new JTextField("100%", 4);
  JTextField tfPageNum = new JTextField("1", 3);
  JLabel lNumPages = new JLabel();

  // constructor
  public JTiffyToolBar() {
    try { jbInit(); }
    catch (Exception e) { e.printStackTrace(); }
  }

  // initialise components
  void jbInit() throws Exception {
    customizeButton(saveBtn, 24, 24, "saveBtn", saveIcon, "save");
    customizeButton(navigationBtn, 24, 24, "navigationBtn", navigationIcon, "navigation");
    customizeButton(zoomInBtn, 24, 24, "zoomInBtn", zoomInIcon, "zoom in");
    customizeButton(zoomOutBtn, 24, 24, "zoomOutBtn", zoomOutIcon, "zoom out");
    customizeButton(zoom1to1Btn, 24, 24, "zoom1to1Btn", zoom1To1Icon, "original size");
    customizeButton(horizScaleBtn, 24, 24, "horizScaleBtn", horizScaleIcon, "scale to fit horizontally");
    customizeButton(winScaleBtn, 24, 24, "winScaleBtn", winScaleIcon, "scale to fit in window");
    customizeButton(antialiasBtn, 38, 24, "antialiasBtn", antialiaIcon, "scale smooth (antialiasing)");
    customizeButton(pgBackBtn, 24, 24, "pgBackBtn", pgBackIcon, "previous page");
    customizeButton(pgFwdBtn, 24, 24, "pgFwdBtn", pgFwdIcon, "next page");
    customizeButton(turnLeftBtn, 24, 24, "turnLeftBtn", turnleftIcon, "rotate left");
    customizeButton(turn180Btn, 24, 24, "turn180Btn", turn180Icon, "rotate 180 deg.");
    customizeButton(turnRghtBtn, 24, 24, "turnRghtBtn", turnrghtIcon, "rotate right");
    customizeButton(mirrorBtn, 24, 24, "mirrorBtn", mirrorIcon, "mirror horizontal");
    customizeButton(flipBtn, 24, 24, "flipBtn", flipIcon, "flip vertical");
    customizeButton(printBtn, 24, 24, "printBtn", printIcon, "print");
    customizeButton(printViewBtn, 24, 24, "printViewBtn", printViewIcon, "print current view");
    customizeButton(invertBtn, 38, 24, "invertBtn", invertIcon, "invert");
    customizeButton(annotationBtn, 24, 24, "annotationBtn", annotationIcon, "annotations");
    customizeButton(helpBtn, 24, 24, "helpBtn", helpIcon, "help");
    setLayout(new FlowLayout(FlowLayout.LEFT, 2, 1));
    add(saveBtn, null); saveBtn.setEnabled(false);
    add(printBtn, null);
    add(printViewBtn, null);
    addToolBarSeparator(this);
    add(navigationBtn, null);
    add(zoomInBtn, null);
    add(zoomOutBtn, null);
    add(tfZoom); tfZoom.addActionListener(this);
    add(zoom1to1Btn, null);
    add(horizScaleBtn, null);
    add(winScaleBtn, null);
    addToolBarSeparator(this);
    add(pgBackBtn, null);
    add(tfPageNum); tfPageNum.addActionListener(this);
    add(lNumPages);
    add(pgFwdBtn, null);
    addToolBarSeparator(this);
    add(turnLeftBtn, null);
    add(turn180Btn, null);
    add(turnRghtBtn, null);
    add(mirrorBtn, null);
    add(flipBtn, null);
    addToolBarSeparator(this);
    add(antialiasBtn, null);
    add(invertBtn, null);
    add(annotationBtn, null);
    addToolBarSeparator(this);
    //addToolBarSeparator();
    add(helpBtn, null);
  }

  void customizeButton(AbstractButton btn, int width, int height, String actionCmd,
                  ImageIcon icon, String toolTipText) {
    btn.setMaximumSize(new Dimension(width, height));
    btn.setPreferredSize(new Dimension(width, height));
    btn.setActionCommand(actionCmd);
    btn.setIcon(icon);
    btn.setLabel("");
    btn.setBorderPainted(false);
    btn.setToolTipText(toolTipText);
    btn.setMinimumSize(new Dimension(width, height));
    btn.addMouseListener(this);
    btn.addActionListener(this);
  }

  /* // simple version of loading ImageIcon from resource as stream (not supported by Netscape Navigator)
  ImageIcon simpleloadImageIcon(String imgName) {
    InputStream is = null;
    ByteArrayOutputStream baos;
    try {
      is = this.getClass().getResourceAsStream(imgName);
    } catch (Throwable e) { };
    if (is == null) {
      System.out.println("Resource not found: " + imgName);
      return null;
    } else {
      baos = new ByteArrayOutputStream();
      try {
        int c;
        while((c = is.read()) >= 0)
          baos.write(c);
        return new ImageIcon(baos.toByteArray());
      } catch(IOException e) { e.printStackTrace(); return null; }
    }
  }
  */

  ImageIcon loadImageIcon(String imgName) {
    try {
      return new ImageIcon(ach.file.ParamUtil.getResourceAsByteArray(imgName, this.getClass()));
    } catch (Exception e) { System.err.println("Resource not found: " + imgName); return null; }
  }

  void addToolBarSeparator(Container c) { // addSeparator() works not as expected
    JButton b = new JButton();
    b.setMaximumSize(new Dimension(2, 24));
    b.setPreferredSize(new Dimension(2, 24));
    b.setMinimumSize(new Dimension(2, 24));
    b.setLabel("");
    c.add(b, null);
  }

  // set imagePanel that should receive button action events
  public void setImagePanel(ImagePanel imagePanel) {
    this.imagePanel = imagePanel;
    imagePanel.addSaveControl(saveBtn);
    saveBtn.setEnabled(imagePanel.btnSave.isEnabled());
    imagePanel.addPrevPageControl(pgBackBtn);
    imagePanel.addNextPageControl(pgFwdBtn);
    imagePanel.addAnnotationsControl(annotationBtn);
    imagePanel.setToolbarController(this);
    // replace AWT Scrollbars used in SmartScrollPane with lightweight JTScrollBar
    imagePanel.sScrPane.sbHoriz = new JTScrollBar(Scrollbar.HORIZONTAL,0,100,0,100);
    imagePanel.sScrPane.sbVert = new JTScrollBar(Scrollbar.VERTICAL,0,100,0,100);
  }

  /**
   * ToolbarController: set text of PageNum TextField to page number
   */
  public void setPageNumText(int pageNum) {
    String pageNumStr = String.valueOf(pageNum);
    if (!tfPageNum.getText().equals(pageNumStr)) // new page
      if (annotationBtn.isEnabled()) // -> check if annotationBtn should be set selected
        annotationBtn.setSelected(true);
      else
        annotationBtn.setSelected(false);
    tfPageNum.setText(String.valueOf(pageNum));
  }

  /**
   * ToolbarController: get text of PageNum TextField converted to int
   */
  public int getPageNum() {
    return Integer.parseInt(tfPageNum.getText());
  }

  /**
   * ToolbarController: set text of numPages Label to number of pages
   */
  public void setNumPagesText(int numPages) {
    lNumPages.setText(" / " + String.valueOf(numPages));
  }

  /**
   * ToolbarController: set text of zoom TextField to zoomFactor
   * (update only if current text is different to avoid unnecessary repaints)
   */
  public void setZoomText(double zoomFactor) {
    String zoomText = Long.toString(java.lang.Math.round(zoomFactor*100)) + "%";
    if (!tfZoom.getText().equals(zoomText))
      tfZoom.setText(zoomText);
  }

  /**
   * ToolbarController: get zoom factor from zoom TextField
   */
  public double getZoomFactor(double defaultZoom) {
    String zoomStr = tfZoom.getText();
    double zoomFactor = defaultZoom;
    try {
      if (zoomStr.indexOf('%') >= 0)
        zoomStr = zoomStr.substring(0,zoomStr.indexOf('%'));
      zoomFactor = Double.valueOf(zoomStr).doubleValue() / 100; // some VMs don't accept Double.parseDouble()
    } catch (Exception e) {  }
    return zoomFactor;
  }

  // implement methods for MouseListener interface
  public void mouseClicked(MouseEvent e) { }
  public void mousePressed(MouseEvent e) { }
  public void mouseReleased(MouseEvent e) { }

  public void mouseEntered(MouseEvent e) {// draw border around button
    if (e.getSource() instanceof AbstractButton)
      ((AbstractButton)(e.getSource())).setBorderPainted(true);
  }

  public void mouseExited(MouseEvent e) {// clear button border
    if (e.getSource() instanceof AbstractButton)
      ((AbstractButton)(e.getSource())).setBorderPainted(false);
  }

  // implement method for ActionListener interface
  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == saveBtn)
      imagePanel.downloadImage();
    if (e.getSource() == zoomInBtn)
      imagePanel.zoomIn();
    else if (e.getSource() == navigationBtn)
      imagePanel.navigation();
    else if (e.getSource() == zoomOutBtn)
      imagePanel.zoomOut();
    else if (e.getSource() == zoom1to1Btn)
      imagePanel.zoom1To1();
    else if (e.getSource() == horizScaleBtn)
      imagePanel.fitHoriz();
    else if (e.getSource() == winScaleBtn)
      imagePanel.fitInWindow();
    else if (e.getSource() == antialiasBtn)
      imagePanel.toggleSmoothScaling();
    else if (e.getSource() == pgBackBtn)
      imagePanel.setPreviousPage();
    else if (e.getSource() == pgFwdBtn)
      imagePanel.setNextPage();
    else if (e.getSource() == turnLeftBtn)
      imagePanel.rotate090();
    else if (e.getSource() == turn180Btn)
      imagePanel.rotate180();
    else if (e.getSource() == turnRghtBtn)
      imagePanel.rotate270();
    else if (e.getSource() == mirrorBtn)
      imagePanel.mirror();
    else if (e.getSource() == flipBtn)
      imagePanel.flip();
    else if (e.getSource() == invertBtn)
      imagePanel.invert();
    else if (e.getSource() == annotationBtn)
      imagePanel.toggleAnnotations();
    else if (e.getSource() == printBtn)
      imagePanel.printImage(true);
    else if (e.getSource() == printViewBtn)
      imagePanel.printCurrentView(true);
    else if (e.getSource() == helpBtn)
      imagePanel.showKeyHelp();
    else if (e.getSource() ==  tfPageNum) {
      try {
        imagePanel.setPageNum(Integer.parseInt(tfPageNum.getText()));
      } catch (Exception x) { imagePanel.updatePageNum(); }
    }
    else if (e.getSource() ==  tfZoom) {
      try {
        String zoomStr = tfZoom.getText();
        if (zoomStr.indexOf('%') >= 0)
          zoomStr = zoomStr.substring(0,zoomStr.indexOf('%'));
        imagePanel.zoom(Double.valueOf(zoomStr).doubleValue() / 100); // some VMs don't accept Double.parseDouble()
      } catch (Exception x) { }
    }
  }

}


